
<!------------------------------------------------------------- 
    This example shows how CFLOCK can be used to guarantee the
    consistency of data updates to variables in the Application, 
	Server, and Session scopes.
	You should copy the following code into an Application.cfm
    file in the wwwroot directory. 
--------------------------------------------------------------->
	<HTML>
	<HEAD>
		<title>Define Session and Application Variables</title>
	</HEAD>
	
	<BASEFONT FACE="Arial, Helvetica" SIZE=2>
	<BODY  bgcolor="#FFFFD5">
	
	<H3>CFAPPLICATION Example</H3>
	
	<P>CFAPPLICATION defines scoping for a ColdFusion application and 
	enables or disables the storing of application and/or session
	variables. This tag is placed in a special file called
	Application.cfm that is run before any other CF template in a
	directory where the Application.cfm file appears.
	<!------------------------------------------------------------- 
	<CFAPPLICATION NAME="ETurtle" SESSIONTIMEOUT=#CreateTimeSpan(0, 0, 
	  0, 60)# SESSIONMANAGEMENT="yes">
	---------------------------------------------------------------> 
	  
	<!------------------------------------------------------------- 
	Initialize the session and application variables that will be 
	used by E-Turtleneck. Use the session scope for the session 
	variables.
	---------------------------------------------------------------> 
	<!----------------------------------------------------------------
	<CFLOCK SCOPE="Session" TIMEOUT="30" TYPE="Exclusive">
		<CFIF NOT IsDefined("session.size")>
			<CFSET session.size = "">
		</CFIF>
		<CFIF NOT IsDefined("session.color")>
			<CFSET session.color = "">
		</CFIF>
	</CFLOCK>
	------------------------------------------------------------------->
	<!---------------------------------------------------------------- 
	Use the application scope for the application variable. This
	variable keeps track of the total number of turtlenecks sold. 
	------------------------------------------------------------------->
	<!---------------------------------------------------------------- 
	<CFLOCK SCOPE="Application" TIMEOUT="30" TYPE="Exclusive">
		<CFIF NOT IsDefined("application.number")>
			<CFSET application.number = 1>
		</CFIF>
	</CFLOCK>
	<CFLOCK SCOPE="Application" TIMEOUT="30" TYPE="ReadOnly">
		<CFOUTPUT>
		E-Turtleneck is proud to say that we have sold #application.number#
		<CFIF #application.number# NEQ 1>
		turtlenecks 
		<CFELSE>
		turtleneck
		</CFIF>
		to date.
		</CFOUTPUT>
    </CFLOCK> 
------------------------------------------------------------------->
<!--- End of Application.cfm --->

<HEAD>
<TITLE>
CFLOCK Example
</TITLE>
</HEAD>

<BASEFONT FACE="Arial, Helvetica" SIZE=2>
<BODY  bgcolor="#FFFFD5">

<H3>CFLOCK Example</H3>

<CFIF IsDefined("form.submit")>
	<CFOUTPUT>
		Thank you for shopping E-Turtleneck. Today you have
		chosen a turtleneck in size <b>#form.size#</b> and in the color
		<b>#form.color#</b>. 
	</CFOUTPUT>
	
	<!----------------------------------------------------------------- 
	 Lock session variables to assign form values to them. 
	-------------------------------------------------------------------> 
	<CFLOCK SCOPE="Session" TIMEOUT="30" TYPE="Exclusive">
		<CFPARAM NAME=session.size Default=#form.size#>
		<CFPARAM NAME=session.color Default=#form.color#>
	</CFLOCK>
	<!------------------------------------------------------------------ 
	Lock application variable application.number to find the total number 
	of turtlenecks sold. 
	-------------------------------------------------------------------> 
	<CFLOCK SCOPE="Application" TIMEOUT="30" TYPE="Exclusive">
		<CFSET application.number = application.number + 1>
	</CFLOCK>
	
<CFELSE><!--- Show the form only if it has not been submitted. --->

<FORM ACTION="cflock.cfm" METHOD="POST">

<P>Congratulations! You have just selected the longest wearing, most comfortable turtleneck in the world. Please indicate the color and size that you wish to buy.</P> 
<table cellspacing="2" cellpadding="2" border="0">
<tr>
    <td>Select a color.</td>
    <td><SELECT TYPE="Text" NAME="color">
		<OPTION>red
		<OPTION>white
		<OPTION>blue
		<OPTION>turquoise
		<OPTION>black
		<OPTION>forest green
		</SELECT>
	</td>
</tr>
<tr>
    <td>Select a size.</td>
    <td><SELECT TYPE="Text" NAME="size" >
		<OPTION>XXsmall
		<OPTION>Xsmall
		<OPTION>small
		<OPTION>medium
		<OPTION>large
		<OPTION>Xlarge
		</SELECT>
	</td>
</tr>
<tr>
    <td>Press Submit when you are finished making your selection.</td>
    <td><INPUT TYPE="Submit" NAME="submit" VALUE="Submit"> 
	</td>
</tr>
</table>
</FORM>
</CFIF>
</HTML>